/**
* @file    MAIN.cpp
* @author  Thales Vieira <thalesv@gmail.com>
* @author  Instituto de Matemtica, UFAL
* @version 0.1
* @date    29/03/2010
*
* @brief   Esqueleto de programa usando a GLUT para
* @brief   o curso de Computao Grfica Interativa
* @brief   Aula 5
*/
//________________________________________________

#include <windows.h>
#include <iostream>
#include <glut.h>

#include <math.h>

#define PI 3.141592653589793238462643

float raio;


void display() {
   // Limpa a tela com a cor preta (RGB: preta)

   glClearColor(0.0, 0.0, 0.0, 0.0);
   glClear(GL_COLOR_BUFFER_BIT);

	//determina tamanho do ponto
	glPointSize(6);
	//determina grossura da linha
	glLineWidth(2);
	//determina cor de desenho
	glColor3f(1.,0.,0.);
	
	//carrega matriz identidade e translada para o centro da tela (0.5,0.5)
	glLoadIdentity();
	glTranslatef(0.5,0.5,0.0);

	//desenha o circulo se o raio tiver sido determinado pelo usuario
	if(raio>0.0)
	{
		glBegin(GL_LINE_STRIP);
			for(float t=0.0;t<=2*PI;t+=0.01)
				glVertex2f(raio*cos(t),raio*sin(t));
		glEnd();
	}
	//desenha um ponto branco no centro do circulo
	glColor3f(1.,1.,1.);
	glBegin(GL_POINTS);
	glVertex2f(0.0,0.0);
	glEnd();

   glutSwapBuffers(); //Atualiza o BUFFER
}

/***
* init():
*   Configura o OpenGL.
*   Configuramos a matriz de 
*   projeo ortogonal ortogonal, neste caso.
***/
void init() {
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glOrtho(0.0,1.0,0.0,1.0,-1.0,1.0);
   glMatrixMode(GL_MODELVIEW);
}

void keyboard_callback(unsigned char key, int x, int y) 
{
	if (key == 'R') 
	{
		printf("\nDigite o raio do circulo: ");
		scanf("%f",&raio);
		glutPostRedisplay();
	}
}

/***
* main():
*    Esta  a funo que  chamada quando executamos o programa. Vamos inicializar janelas
e configurar o GLUT aqui.
***/
int main(int argc, char** argv) 
{
	//inicializacao do raio
	raio=-1.0;

   // Inicializa o ambiente do GLUT
   glutInit(&argc, argv);

   // Configuraes de janela e de sistema de cor.
   glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
   glutInitWindowSize(250,250);
   glutInitWindowPosition(100,100);

   // Cria a janela do GLUT com o ttulo "Hello World!"
   glutCreateWindow("Hello World!");

   // Determina qual funo deve ser chamada para desenhar na tela (draw)
   glutDisplayFunc(display);

  glutKeyboardFunc(keyboard_callback); 

   // Esta funo inicializa configuraes do OpenGL
   init();

   // Exibe a janela e desenha na tela, usando a funo determinada em glutDisplayFunc
   glutMainLoop();
   return 0;
}