/**
* @file    MAIN.cpp
* @author  Thales Vieira <thalesv@gmail.com>
* @author  Instituto de Matemtica, UFAL
* @version 0.1
* @date    29/03/2010
*
* @brief   Esqueleto de programa usando a GLUT para
* @brief   o curso de Computao Grfica Interativa
* @brief   Aula 5
*/
//________________________________________________

#include <windows.h>
#include <iostream>
#include <glut.h>

#include <math.h>

#define PI 3.141592653589793238462643

float sx,sy;
float tx,ty;
float rot;


void display() {
   // Limpa a tela com a cor preta (RGB: preta)

   glClearColor(0.0, 0.0, 0.0, 0.0);
   glClear(GL_COLOR_BUFFER_BIT);

	//determina grossura da linha
	glLineWidth(2);
	//determina cor de desenho
	glColor3f(1.,0.,0.);
	
	//carrega matriz identidade e aplica transformaes na forma T*R*S(x)
	glLoadIdentity();
	glTranslatef(tx,ty,0.0);
	glRotatef(rot,0.,0.,1.);
	glScalef(sx,sy,1.0);

	//desenha um quadrado centrado na origem de lado 0.4
	glBegin(GL_LINE_LOOP);
		glVertex2f(0.2,-0.2);
		glVertex2f(0.2,0.2);
		glVertex2f(-0.2,0.2);
		glVertex2f(-0.2,-0.2);
	glEnd();
	

   glutSwapBuffers(); //Atualiza o BUFFER
}

/***
* init():
*   Configura o OpenGL.
*   Configuramos a matriz de 
*   projeo ortogonal ortogonal, neste caso.
***/
void init() {
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glOrtho(0.0,1.0,0.0,1.0,-1.0,1.0);
   glMatrixMode(GL_MODELVIEW);
}

void keyboard_callback(unsigned char key, int x, int y) 
{
	if (key == 'R') 
	{
		printf("\nDigite o angulo de rotacao: ");
		scanf("%f",&rot);
		glutPostRedisplay();
	}
	if (key == 'T') 
	{
		printf("\nDigite os parametros de translacao tx ty: ");
		scanf("%f %f",&tx,&ty);
		glutPostRedisplay();
	}
	if (key == 'S') 
	{
		printf("\nDigite os parametros de escala sx sy: ");
		scanf("%f %f",&sx,&sy);
		glutPostRedisplay();
	}
}

/***
* main():
*    Esta  a funo que  chamada quando executamos o programa. Vamos inicializar janelas
e configurar o GLUT aqui.
***/
int main(int argc, char** argv) 
{
	//inicializacao dos parametros das transformacoes
	sx=sy=1.;
	tx=ty=0.;
	rot=0.;

   // Inicializa o ambiente do GLUT
   glutInit(&argc, argv);

   // Configuraes de janela e de sistema de cor.
   glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
   glutInitWindowSize(250,250);
   glutInitWindowPosition(100,100);

   // Cria a janela do GLUT com o ttulo "Hello World!"
   glutCreateWindow("Hello World!");

   // Determina qual funo deve ser chamada para desenhar na tela (draw)
   glutDisplayFunc(display);

  glutKeyboardFunc(keyboard_callback); 

   // Esta funo inicializa configuraes do OpenGL
   init();

   // Exibe a janela e desenha na tela, usando a funo determinada em glutDisplayFunc
   glutMainLoop();
   return 0;
}